/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.StatusDto;
import com.portofolio.service.StatusService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/status")
public class StatusController extends LocaleController {
	@Lazy
	@Autowired
	private StatusService statusService;
	
	@ApiOperation("Api Untuk Menyimpan Status")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody StatusDto dto, HttpServletRequest request) {
		Map<String, Object> result = statusService.save(dto);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Status")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> find(
			@RequestParam(value = "dir", defaultValue = "namaStatus") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaStatus", required = false, defaultValue = "") String namaStatus) {
		Map<String, Object> result = statusService.grid(sort, dir, namaStatus);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Semua Status")
	@GetMapping("/combo")
	public ResponseEntity<Map<String, Object>> combo(
			@RequestParam(value = "dir", defaultValue = "namaStatus") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaStatus", required = false, defaultValue = "") String namaStatus) {
		Map<String, Object> result = statusService.combo(sort, dir, namaStatus);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status")
	@GetMapping("/findByKdStatus")
	public ResponseEntity<Map<String, Object>> findByKdStatus(
			@RequestParam(value = "kdStatus", required = true)Integer kdStatus,
			@RequestParam(value = "isHierarki", required = true) boolean isHierarki
			) {
		Map<String, Object> result = statusService.findByKdStatus(kdStatus, isHierarki);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Update Status")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdStatus", required = true) Integer kdStatus,
			@RequestParam(value = "version", required = true) Integer version, 
			@Valid @RequestBody StatusDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = statusService.update(entity,kdStatus,version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	@ApiOperation("Api Untuk Delete Status")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> delete(
			@RequestParam(value = "kdStatus", required = true) Integer kdStatus,
			@RequestParam(value = "version", required = true) Integer version,
			HttpServletRequest request) {
		Map<String, Object> result = statusService.delete(kdStatus, version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status Pegawai")
	@GetMapping("/comboStatusPegawai")
	public ResponseEntity<Map<String, Object>> comboStatusPegawai(
			@RequestParam(value = "sort", required = true,defaultValue = "desc")String sort,
			@RequestParam(value = "dir", required = true,defaultValue = "namaStatus") String dir,
			@RequestParam(value = "namaStatus", required = false) String namaStatus
			) {
		Integer statusPegawaiHead= Integer.parseInt(statusService.getSettingDataFixed("StatusPegawaiHead").getNilaiField());
		Map<String, Object> result = statusService.comboStatusPegawai(sort, dir,namaStatus,statusPegawaiHead);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status Rawat")
	@GetMapping("/comboStatusRawat")
	public ResponseEntity<Map<String, Object>> comboStatusRawat(
			@RequestParam(value = "sort", required = true,defaultValue = "desc")String sort,
			@RequestParam(value = "dir", required = true,defaultValue = "namaStatus") String dir,
			@RequestParam(value = "namaStatus", required = false) String namaStatus
			) {
		Integer statusRawatHead= Integer.parseInt(statusService.getSettingDataFixed("StatusRawatHead").getNilaiField());
		Map<String, Object> result = statusService.comboStatusPegawai(sort, dir,namaStatus,statusRawatHead);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status Antrian")
	@GetMapping("/comboStatusAntrian")
	public ResponseEntity<Map<String, Object>> comboStatusAntrian(
			@RequestParam(value = "sort", required = true,defaultValue = "desc")String sort,
			@RequestParam(value = "dir", required = true,defaultValue = "namaStatus") String dir,
			@RequestParam(value = "namaStatus", required = false) String namaStatus
			) {
		Integer statusAntrianHead= Integer.parseInt(statusService.getSettingDataFixed("StatusAntrianHead").getNilaiField());
		Map<String, Object> result = statusService.comboStatusPegawai(sort, dir,namaStatus,statusAntrianHead);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status Antrian")
	@GetMapping("/comboStatusKeperluan")
	public ResponseEntity<Map<String, Object>> comboStatusKeperluan(
			@RequestParam(value = "sort", required = true,defaultValue = "desc")String sort,
			@RequestParam(value = "dir", required = true,defaultValue = "namaStatus") String dir,
			@RequestParam(value = "namaStatus", required = false) String namaStatus
			) {
		Integer statusKeperluanHead= Integer.parseInt(statusService.getSettingDataFixed("StatusKeperluanHead").getNilaiField());
		Map<String, Object> result = statusService.comboStatusPegawai(sort, dir,namaStatus,statusKeperluanHead);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Status Antrian")
	@GetMapping("/comboStatusPerkawinan")
	public ResponseEntity<Map<String, Object>> comboStatusPerkawinan(
			@RequestParam(value = "sort", required = true,defaultValue = "desc")String sort,
			@RequestParam(value = "dir", required = true,defaultValue = "namaStatus") String dir,
			@RequestParam(value = "namaStatus", required = false) String namaStatus
			) {
		Integer statusPerkawinanHead= Integer.parseInt(statusService.getSettingDataFixed("StatusPerkawinanHead").getNilaiField());
		Map<String, Object> result = statusService.comboStatusPegawai(sort, dir,namaStatus,statusPerkawinanHead);
		return RestUtil.getJsonResponse(result);
	}
	
	
	

}
